
import java.util.Vector;

import jpl.Atom;
import jpl.JPL;
import jpl.PrologException;
import jpl.Query;
import jpl.Term;
import jpl.Util;
import jpl.Variable;
 /**
 * @author Damian Janicki
 *
 */



@SuppressWarnings("deprecation")
public class VardaControl {
	enum eOption{
		eOptionArdCollapse,
		eOptionArdTphCollapse,
		eOptionGenerateXtt,
		eOptionOptimizeXtt,
	}

	/**
	 * inicjuje jpl oraz consultuje pliki: varda.pl GuiQuery.pl
	 */
	public void initVarda(){
		JPL.init();

		Query queryConsult = new Query("consult", new Atom("varda/varda.pl"));
		queryConsult.hasSolution();

		Query  queryGuiPl = new Query("consult", new Atom("pl/gui_query.pl"));
		queryGuiPl.hasSolution();

		//TODO wyrzucic to pozniej
//		Query  queryTemp = new Query("consult", new Atom("pl/temp.pl"));
//		queryTemp.hasSolution();
//
//		Query  queryTestMy = new Query("my_test");
//		queryTestMy.hasSolution();


	}/**initVarda method*/


	/**
	 * dodaje nowy atrybut do varda
	 * @param
	 * @return
	 */
	public boolean addAttribute(String A_attrName){
		Query add = new Query("ard_att_add", new Atom(A_attrName));
		return add.hasSolution();
	}/**addAttribute method*/

	/**
	 * dodaje nowy property
	 * @param
	 * @return
	 */
	public boolean addProperty(String A_propertyName){
		Term queryTerm = Util.stringArrayToList(new String[]{A_propertyName});
		Query add = new Query("ard_property_add", queryTerm);
		return add.hasSolution();
	}/**addProperty method*/

	/**
	 * pobiera liste wszystkich atrybutow z modelu
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Vector<String> getAttributes(){

		Vector<String> attrVector = new Vector<String>();

		Variable attrVar 	= new Variable(new String("Varible"));
		Term[] 	 attrTerm 	= {attrVar};
		Query 	 attrQuery 	= new Query("ard_att", attrTerm);

		java.util.Hashtable[] attrSolution = attrQuery.allSolutions();

		for(int i = 0; i < attrSolution.length; i++ ){
			Term wynik = (Term)attrSolution[i].get("Varible");
			attrVector.add(wynik.name());
		}

		return attrVector;
	}/**getAttributes*/

	/**
	 * @return
	 */
	public Vector<Vector<String>> getMyProp(){

		Vector<Vector<String>> attrVector = new Vector<Vector<String>>();

		Variable attrVar 	= new Variable(new String("Varible"));
		Term[] 	 attrTerm 	= {attrVar};
		Query 	 attrQuery 	= new Query("list_prop", attrTerm);

		java.util.Hashtable[] attrSolution = attrQuery.allSolutions();

		for(int i = 0; i < attrSolution.length; i++ ){
			Term[] propTermArr = Util.listToTermArray((Term)attrSolution[i].get("Varible"));
			Vector<String> temp = new Vector<String>();

			for(int idx2 = 0; idx2 < propTermArr.length; idx2++){
				temp.add(propTermArr[idx2].name());
			}

			attrVector.add(temp);
		}

		return attrVector;
	}/**getAttributes*/

	/**
	 * pobiera z modelu liste propertisow
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static Vector<Vector<String>> getPropertys(){
		Vector<Vector<String>> propertyVector = new Vector<Vector<String>>();

		Variable propertyVar 	= new Variable(new String("Varible"));
		Term[] 	 propertyTerm 	= new Term[]{propertyVar};
		Query 	 propertyQuery 	= new Query("ard_property", propertyTerm);

		java.util.Hashtable[] propertySolution = propertyQuery.allSolutions();

		for(int nIdx = 0; nIdx < propertySolution.length; nIdx++ ){
			Term[] propTermArr = Util.listToTermArray((Term)propertySolution[nIdx].get("Varible"));

			Vector<String> tempVector = new Vector<String>();
//			String strProperty = new String("");
			for(int n = 0; n < propTermArr.length; n++){
				tempVector.add(propTermArr[n].name());
//				if(n != propTermArr.length - 1)
//					strProperty += ", ";
			}
			propertyVector.add(tempVector);
		}
		return propertyVector;
	}/**getProperty  method*/


	/**
	 * zwraca liste attrybutow, ale usuwa z niej te atrybity ktore sa jednoczesnie propertys
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Vector<String> getAttributesToMakeProp(){
		Vector<String> attrVector = new Vector<String>();


		Variable attrVar 	= new Variable(new String("Varible"));
		Term[] 	 attrTerm 	= {attrVar};
		Query 	 attrQuery 	= new Query("list_attr_to_prop", attrTerm);

		java.util.Hashtable[] attrSolution = attrQuery.allSolutions();

		for(int i = 0; i < attrSolution.length; i++ ){
			Term wynik = (Term)attrSolution[i].get("Varible");
			attrVector.add(wynik.name());
		}

		return attrVector;
	}/**getAttributesToProperty method*/


	/**
	 * Zwraca tylko te atrubuty ktore moga byc uzywane przy operacji finalize
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Vector<String> getFinalizeAttr(){
		Vector<String> propertyVector = new Vector<String>();

		Variable propertyVar 	= new Variable(new String("Varible"));
		Term[] 	 propertyTerm 	= new Term[]{propertyVar};
		Query 	 propertyQuery 	= new Query("ard_finalizeable", propertyTerm);

		java.util.Hashtable[] propertySolution = propertyQuery.allSolutions();

		for(int nIdx = 0; nIdx < propertySolution.length; nIdx++ ){
			Term[] propTermArr = Util.listToTermArray((Term)propertySolution[nIdx].get("Varible"));

			String strProperty = propTermArr[0].name();
			if(Character.isUpperCase(strProperty.charAt(0)))
				propertyVector.add(strProperty);
		}
		return propertyVector;
	}


	/**
	 *
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public Vector<Vector<String>> getSplitableAttributes(){
		Vector<Vector<String>> attrData = new Vector<Vector<String>>();

		Variable propertyVar 	= new Variable(new String("Varible"));
		Term[] 	 propertyTerm 	= new Term[]{propertyVar};
		Query 	 propertyQuery 	= new Query("ard_splitable", propertyTerm);

		java.util.Hashtable[] propertySolution = propertyQuery.allSolutions();

		for(int nIdx = 0; nIdx < propertySolution.length; nIdx++ ){
			Term[] propTermArr = Util.listToTermArray((Term)propertySolution[nIdx].get("Varible"));

			Vector<String> tempVect = new Vector<String>();

			for(int idx2 = 0; idx2 < propTermArr.length; idx2++){
				tempVect.add(propTermArr[idx2].name());
			}
			attrData.add(tempVect);
		}
		return  attrData;
	}

	/**
	 * @param A_property
	 * @param A_attrTable
	 * @return
	 */
	public boolean finalize(String A_property, String[] A_attrTable){

		Term propTerm = Util.stringArrayToList(new String[]{A_property});
		Term attrTerm = Util.stringArrayToList(A_attrTable);

		Term[] queryTerm = new Term[]{propTerm, attrTerm};

		Query finalizeQuery = new Query("ard_finalize", queryTerm);
		return finalizeQuery.hasSolution();
	}

	@SuppressWarnings("unchecked")
	public Vector<String> getFinalizableAttr(){
		Vector<String> attrVector = new Vector<String>();

		Variable attrVar 	= new Variable(new String("Varible"));
		Term[] 	 attrTerm 	= {attrVar};
		Query 	 attrQuery 	= new Query("ard_finalizable_attr", attrTerm);

		java.util.Hashtable[] attrSolution = attrQuery.allSolutions();

		for(int i = 0; i < attrSolution.length; i++ ){
			Term wynik = (Term)attrSolution[i].get("Varible");
			attrVector.add(wynik.name());
		}

		return attrVector;
	}

	/**
	 *
	 * @return
	 */
	public boolean showXTT(){
		Query save = new Query("sxt");
		return save.hasSolution();
	}

	/**
	 *
	 * @return
	 */
	public boolean showArd(){
		Query save = new Query("sar");
		return save.hasSolution();
	}

	/**
	 * @return
	 */
	public boolean showTph(){
		Query save = new Query("shi");
		return save.hasSolution();
	}

	/**
	 * @return
	 */
	public boolean showTphArd(){
		Query save = new Query("sha");
		return save.hasSolution();
	}


	/**
	 *
	 * @return
	 */
	public boolean purgeModel(){
		Query purg = new Query("pur");
		return purg.hasSolution();
	}

	/**
	 *
	 * @return
	 */
	public boolean killAllDisp(){
		Query purg = new Query("kid");
		return purg.hasSolution();
	}

	/**
	 * Wykonuje operacje split
	 * @param splitData
	 * @return
	 */
	public boolean split(SplitData splitD){
		boolean retVal = false;

		//stworzenie parametru pietszego
		Term splitParam1 = Util.stringArrayToList(vectorStringToArray(splitD.getPropertysToSplit()));

		//stworzenie parametru drugiego
		Term splitParam2 = vectorStringStringToTermArray(splitD.getSplitParam2());

		//stworzenie parametru trzeciego
		Term[] tempTermArr = new Term[splitD.getSizeSplitParam3()];

		int nextIndex = 0;
		Term temp = null;
		for(int idx = 0; idx < splitD.getSplitParam3().size(); idx++){

			if(splitD.getSplitParam3().get(idx).size() == 2){
				temp = vectorStringStringToTermArray(splitD.getSplitParam3().get(idx));
				tempTermArr[nextIndex] = temp;
				nextIndex++;
			}
		}
		System.out.println(tempTermArr.length);

		Term splitParam3 = Util.termArrayToList(tempTermArr);
		System.out.println(splitParam3.toString());

		//term
		Term[] splitTerm = new Term[]{splitParam1, splitParam2, splitParam3};

		Query splitQuery = new Query("ard_split", splitTerm);
		retVal = splitQuery.hasSolution();

		return retVal;
	}


	/**
	 * Tworzy tablice stringow z wetkora
	 * @param strVect
	 * @return
	 */
	public static String[] vectorStringToArray(Vector<String> strVect){
		String[] stringArr = new String[strVect.size()];

		for(int idx = 0; idx < strVect.size() ;idx++){
			stringArr[idx] = strVect.get(idx);
		}

		return stringArr;
	}

	/**
	 * Tworzy liste list z wektora wektorow stringa i zwraca jako Term
	 * @param stringVect
	 * @return
	 */
	public static Term vectorStringStringToTermArray(Vector<Vector<String>> stringVect){
		Term[] tempTermTable = new Term[stringVect.size()];
		for(int idx1 = 0; idx1 < stringVect.size(); idx1++){
			Term singleTerm = Util.stringArrayToList(vectorStringToArray(stringVect.get(idx1)));
			tempTermTable[idx1] = singleTerm;
		}

		Term termParam = Util.termArrayToList(tempTermTable);
		return termParam;
	}

	/**
	 * @param dir
	 * @param option
	 * @return
	 */
	public boolean saveFile(String queryStr, String dir){
		if(queryStr.compareTo("sxt_file") == 0){

			//aby zapisac diagram xtt trzeba go najpierw stworzyc
			Query makeXtt = new Query("gax");
			boolean temp = makeXtt.hasSolution();
			if(!temp){
				return false;
			}
		}

		Query query;
		query = new Query(queryStr, new Atom(dir));

		return query.hasSolution();
	}


	/**
	 * @param opt
	 * @return
	 */
	public boolean otherOption(eOption opt){
		String queryStr = new String();

		switch(opt){
			case eOptionArdCollapse:
				queryStr = "hic";
				break;
			case eOptionArdTphCollapse:
				queryStr = "tic";
				break;
			case eOptionGenerateXtt:
				queryStr = "gax";
				break;
			case eOptionOptimizeXtt:
				queryStr = "xop";
				break;
		}
		Query myQuery = new Query(queryStr);
		return myQuery.hasSolution();
	}

	/**
	 * @param strQuery
	 * @return
	 */
	public boolean userQuery(String strQuery){
//		boolean bVal = false;
		Query myQuery = new Query(strQuery);
		try{
			myQuery.hasSolution();
		}catch(PrologException e){
			return false;
		}
		return true;
	}

}/**VardaControl class*/

